diff --git a/libr/anal/esil.c b/libr/anal/esil.c
index b66e6e3403bf5..a82a3b3d523ff 100644
--- a/libr/anal/esil.c
+++ b/libr/anal/esil.c
@@ -301,10 +301,12 @@ static int internal_esil_reg_read(RAnalEsil *esil, const char *regname, ut64 *nu
 }
 
 static int internal_esil_reg_write(RAnalEsil *esil, const char *regname, ut64 num) {
-	RRegItem *reg = r_reg_get (esil->anal->reg, regname, -1);
-	if (reg) {
-		r_reg_set_value (esil->anal->reg, reg, num);
-		return true;
+	if (esil && esil->anal) {
+		RRegItem *reg = r_reg_get (esil->anal->reg, regname, -1);
+		if (reg) {
+			r_reg_set_value (esil->anal->reg, reg, num);
+			return true;
+		}
 	}
 	return false;
 }
